USE SCRATCH;

/*XML trick*/

--generate a CSV

DECLARE @csv VARCHAR(MAX) 

SELECT  @csv = STUFF(( SELECT   ',' + CONVERT(VARCHAR(MAX), n)
                       FROM     dbo.Numbers n
                     FOR
                       XML PATH('')
                     ), 1, 1, '')

SELECT @csv 

--column name becomes tag
SELECT  n
FROM    dbo.Numbers n
FOR     XML PATH('')

--no column name? no tag!
SELECT  ',' + CONVERT(VARCHAR(MAX), n)
FROM    dbo.Numbers n
FOR     XML PATH('')


--split a csv string
--replace commas with end tag, start tag
DECLARE @x XML = '<x>' --start tag
		+ REPLACE(@csv, ',', '</x><x>') --replace commas with end tag, start tag 
		+ '</x>' --end tag

SELECT @x 

SELECT x.value('.', 'int')
FROM @x.nodes('//x') T(x)



