/* .modify()

need to explain the following: 
1.	.exist()
2.	axes, predicate, node test
3.  .query()
4.	.value()
5.	.nodes()
6.	.modify() 
7.  sql:variable(), sql:column() 	
*/

USE SCRATCH;

--update method
--used in SET statement or SET clause of UPDATE statement
--insert, update, or delete functions

DECLARE @x XML
SET @x = '<RingBufferTarget truncated="0" processingTime="1" totalEventsProcessed="1004" eventCount="995" droppedCount="0" memoryUsed="1041882">
  <event name="module_end" package="sqlserver" timestamp="2013-10-08T19:45:16.315Z">
    <data name="source_database_id">
      <type name="uint32" package="package0" />
      <value>10</value>
    </data>
    <data name="object_id">
      <type name="int32" package="package0" />
      <value>565577053</value>
    </data>
    <data name="duration">
      <type name="uint64" package="package0" />
      <value>1</value>
    </data>
    <data name="row_count">
      <type name="uint64" package="package0" />
      <value>1</value>
    </data>
    <data name="line_number">
      <type name="int32" package="package0" />
      <value>6</value>
    </data>
    <data name="offset">
      <type name="int32" package="package0" />
      <value>98</value>
    </data>
    <data name="offset_end">
      <type name="int32" package="package0" />
      <value>124</value>
    </data>
    <data name="object_type">
      <type name="ansi_string" package="package0" />
      <value>P </value>
    </data>
    <data name="object_name">
      <type name="unicode_string" package="package0" />
      <value>p1</value>
    </data>
    <data name="statement">
      <type name="xml" package="package0" />
      <value>EXEC p1 @x</value>
    </data>
  </event>
</RingBufferTarget>'

SELECT @x

--delete all key and value nodes except for REMOTE_ADDR
SET @x.modify('delete (//data[@name!="duration"]/*)')
SELECT @x

--delete all empty nodes
SET @x.modify('delete (//data)[count(value)=0]')

SELECT @x

--insert a new RubricValue
SET @x.modify('insert <data /> as last into (//event)[1]')
SET @x.modify('insert attribute name {"new_node"} into (//data)[count(@name)=0][1]')
SET @x.modify('insert <value>Hello World!</value> into (//event/data)[@name="new_node"][1]')

SELECT @X 

 
SET @x.modify('replace value of (//value[text()="Hello World!"]/text())[1] with "Goodbye!"')
SELECT @x
