/* sql:variable, sql:column

need to explain the following: 
1.	.exist()
2.	axes, predicate, node test
3.  .query()
4.	.value()
5.	.nodes()
6.	.modify() 
7.  sql:variable(), sql:column() 	
*/

USE SCRATCH;

DECLARE @position INT = 1

SELECT  ID
	  , x.query('//event[1]/data')
      , x.query('//event[1]/data[sql:variable("@position")]')
      , x.query('//event[1]/data[sql:column("ID")]')
FROM   dbo.Summit_2013_XML sx


/*
CREATE TABLE Numbers (n INT)

INSERT INTO Numbers (n)
SELECT TOP 1000 ROW_NUMBER() OVER (ORDER BY c.name)
FROM master.sys.columns c
	CROSS JOIN master.sys.columns c1	
*/

SELECT  TOP 10 n
	  ,  x.query('//event[1]/data[sql:column("n")]') x
FROM   Numbers n
		CROSS JOIN dbo.Summit_2013_XML sx
		WHERE sx.ID=1  
ORDER BY n 

--count function
SELECT x.query('count(//event)')
FROM dbo.Summit_2013_XML sx

SELECT x.query('count(//event[1]/data)')
FROM dbo.Summit_2013_XML sx

--contains function
SELECT x.query('//data/type[contains(@name, "int")]/../..')
FROM dbo.Summit_2013_XML sx
