USE SCRATCH;

SELECT *
FROM dbo.Summit_2013_XML sx

/*FLWOR - for, let, where, order by, return*/
--simplest FLWOR statemement (for, let) return

SELECT x.query('for $e in RingBufferTarget/event
				return data($e/@name)')
FROM dbo.Summit_2013_XML sx

--make it element centric
SELECT x.query('for $e in RingBufferTarget/event
				return <row>{string($e/@name)}</row>')
FROM dbo.Summit_2013_XML sx

--use let, add an additional element
SELECT x.query('for $e in RingBufferTarget/event
				let $t := $e/@timestamp
				return <row><name>{string($e/@name)}</name><ts>{data($t)}</ts></row>')
FROM dbo.Summit_2013_XML sx

--use let without for; completely impractical example
SELECT x.query('let $s := "Hello World!"
				return $s')
FROM dbo.Summit_2013_XML sx
