USE SCRATCH;

/*
how to pull xml data from extended events into a table
search "extended events xml"

http://blogs.msdn.com/b/extended_events/archive/2010/03/09/reading-event-data-101-what-s-up-with-the-xml.aspx

*/

/*OPENXML --improved for SQL 2005*/
DECLARE @x XML

SELECT TOP 1
        @x = x
FROM    dbo.Summit_2013_XML sx

SELECT  @x 

DECLARE @ix INT
EXEC sp_xml_preparedocument @ix OUTPUT, @x

SELECT  *
FROM    OPENXML(@ix, '//data', 1) 
WITH (Name VARCHAR(100) './@name' ,
Val VARCHAR(100) './value'
	) 

EXEC sp_xml_removedocument @ix
