USE SCRATCH;

/* axes, predicate, node test

need to explain the following: 
1.	.exist()
2.	axes, predicate, node test
3.  .query()
4.	.value()
5.	.nodes()
6.	.modify() 
7.  sql:variable(), sql:column() 	
*/

SELECT TOP 1 x
FROM dbo.Summit_2013_XML sx

/*Axes*/
--root
SELECT TOP 1 x.exist('.')
FROM dbo.Summit_2013_XML sx

--1 node
SELECT TOP 1 x.exist('/RingBufferTarget')
FROM dbo.Summit_2013_XML sx

--any node
SELECT TOP 1 x.exist('/RingBufferTarget//value')
FROM dbo.Summit_2013_XML sx

--parent
SELECT TOP 1 x.exist('//value/../../data')
FROM dbo.Summit_2013_XML sx

/*will show attribute and all nodes with the .query() method*/


/*node test*/
--refers to the text value of the xQuery statement

SELECT TOP 1 x.exist('/RingBufferTarget')
FROM dbo.Summit_2013_XML sx

SELECT TOP 1 x.exist('/root')
FROM dbo.Summit_2013_XML sx


/*predicate*/
--evaluation; kind of like a where clause
SELECT ID, x
FROM dbo.Summit_2013_XML sx
WHERE x.exist ('//event[@timestamp="2013-10-08T19:35:04.457Z"]') = 1

--positional; 1-based
SELECT ID, x
FROM dbo.Summit_2013_XML sx
WHERE x.exist ('//event[500]') = 1


